<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item prop="code">
  <template #label>
    <span>
      {{ t('ProductionPlan.Task.dialogCodeLabel') }}
      <el-tooltip :content="t('ProductionPlan.Task.dialogCodeTooltip')" placement="top">
        <Icon icon="ep:question-filled" />
      </el-tooltip>
    </span>
  </template>
  <el-row :gutter="10" style="width: 100%;">
    <el-col :xs="24" :sm="18" :md="16" :lg="14" :xl="12">
      <el-input 
        :disabled="formData.isCode == true || formType === 'update'" 
        v-model="formData.code" 
        :placeholder="t('ProductionPlan.Task.dialogCodePlaceholder')"
      />
    </el-col>
    <el-col :xs="24" :sm="6" :md="4" :lg="3" :xl="2">
      <div>
        <el-switch 
          v-model="formData.isCode" 
          :disabled="formType === 'update'"
        />
      </div>
    </el-col>
  </el-row>
</el-form-item>
      <el-form-item :label="t('ProductionPlan.Task.dialogDeliveryDateLabel')" prop="deliveryDate">
        <el-date-picker
          v-model="formData.deliveryDate"
          type="date"
          value-format="x"
          :placeholder="t('ProductionPlan.Task.dialogDeliveryDatePlaceholder')"
          class="!w-full"
        />
      </el-form-item>
      <el-form-item :label="t('ProductionPlan.Task.dialogTaskTypeLabel')" prop="taskType">
        <template #label>
            <span>
              {{ t('ProductionPlan.Task.dialogTaskTypeLabel') }}
              <el-tooltip :content="t('ProductionPlan.Task.dialogTaskTypeTooltip')" placement="top">
                <Icon icon="ep:question-filled" />
              </el-tooltip>
            </span>
        </template>
        <el-radio-group v-model="formData.taskType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_TASK_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>

      <el-form-item :label="t('ProductionPlan.Task.dialogRemarkLabel')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('ProductionPlan.Task.dialogRemarkPlaceholder')" type="textarea"/>
      </el-form-item>

    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('ProductionPlan.Task.dialogSubmitButtonText') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('ProductionPlan.Task.dialogCancelButtonText') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import {DICT_TYPE, getStrDictOptions} from '@/utils/dict'
import { TaskApi, TaskVO } from '@/api/mes/task'

/** 生产任务单 表单 */
defineOptions({ name: 'TaskForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  orderDate: undefined,
  deliveryDate: undefined,
  status: undefined,
  taskType: undefined,
  processInstanceId: undefined,
  remark: undefined,
  isEnable: undefined,
  isCode: undefined
})
const formRules = reactive({
  deliveryDate: [{ required: true, message: t('ProductionPlan.Task.validatorDeliveryDateRequired'), trigger: 'blur' }],
  taskType: [{ required: true, message: t('ProductionPlan.Task.validatorTaskTypeRequired'), trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TaskApi.getTask(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TaskVO
    if (formType.value === 'create') {
      await TaskApi.createTask(data)
      message.success(t('common.createSuccess'))
    } else {
      await TaskApi.updateTask(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    orderDate: undefined,
    taskType: '订单任务',
    deliveryDate: undefined,
    status: undefined,
    processInstanceId: undefined,
    remark: undefined,
    isEnable: true,
    isCode: true
  }
  formRef.value?.resetFields()
}
</script>
